package io.gitlab.jfronny.inceptum.gtk.control

import io.github.jwharm.javagi.util.ListIndexModel.ListIndex
import io.gitlab.jfronny.inceptum.launcher.system.instance.Instance
import org.gnome.gtk.*
import org.pango.EllipsizeMode
import org.pango.WrapMode

class InstanceGridEntryFactory(instanceList: List<Instance>) : SignalListItemFactory() {
    init {
        //TODO better design
        onSetup { item ->
            val box = Box(Orientation.VERTICAL, 5)

            val thumbnail = InstanceThumbnail()
            box.append(thumbnail)

            val label = Label(null as String?)
            label.setSizeRequest(192, -1)
            label.maxWidthChars = 20
            label.justify = Justification.CENTER
            label.halign = Align.START
            label.hexpand = true
            label.valign = Align.CENTER
            label.ellipsize = EllipsizeMode.MIDDLE
            label.lines = 3
            label.wrap = true
            label.wrapMode = WrapMode.WORD_CHAR
            label.marginTop = 10
            box.append(label)
//            Label label = new Label(Str.NULL);
//            label.setXalign(0);
//            label.setWidthChars(20);
//            label.setMarginEnd(10);
//            box.append(label);
//
//            Button launch = new Button();
//            launch.setIconName(new Str("computer-symbolic"));
//            launch.setTooltipText(I18n.str("instance.launch"));
//            launch.setHasTooltip(GTK.TRUE);
//            box.append(launch);
//
//            Button openDir = new Button();
//            openDir.setIconName(new Str("folder-symbolic"));
//            openDir.setTooltipText(I18n.str("instance.directory"));
//            openDir.setHasTooltip(GTK.TRUE);
//            box.append(openDir);
            (item as ListItem).setChild(box)
            //TODO server launch with network-server-symbolic
            //TODO kill current instance
        }
        onBind { item ->
//            Label label = new Label(item.getChild().getFirstChild().cast());
//            Button launch = new Button(label.getNextSibling().cast());
//            Button openDir = new Button(launch.getNextSibling().cast());
//            InstanceList.Entry instance = instanceList.get(ListIndex.toIndex(item));
//            label.setText(new Str(instance.toString()));
//            launch.onClicked(() -> GtkMenubar.launch(instance));
//            openDir.onClicked(() -> Utils.openFile(instance.path().toFile()));

            val li = item as ListItem

            val box = li.getChild() as Box
            val thumbnail = InstanceThumbnail.castFrom(box.firstChild as Stack)
            val label = thumbnail.nextSibling as Label

            val instance = instanceList[(li.item as ListIndex).index]
            thumbnail.bind(instance)
            label.text = instance.toString()
        }
    }
}
